<?php

declare(strict_types=1);

namespace Dedi\SyliusSettingsPlugin\DependencyInjection;

use Dedi\SyliusSettingsPlugin\Service\SettingsFactory;
use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

class Configuration implements ConfigurationInterface
{
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder('dedi_sylius_settings');
        $treeBuilder
            ->getRootNode()
            ->children()
                ->arrayNode('roles')
                ->defaultValue(['ROLE_ADMINISTRATION_ACCESS', 'ROLE_API_ACCESS'])
                    ->scalarPrototype()->end()
                ->end()
                ->arrayNode('plugins')
                ->useAttributeAsKey('name')
                ->arrayPrototype()
                    ->children()
                        ->scalarNode('model')->end()
                        ->scalarNode('factory')->defaultValue(SettingsFactory::class)->end()
                        ->scalarNode('provider')->end()
                        ->arrayNode('keys')
                            ->scalarPrototype()->end()
                        ->end()
                    ->end()
                ->end()
            ->end();

        return $treeBuilder;
    }
}
