<?php

declare(strict_types=1);

namespace Dedi\SyliusSettingsPlugin\Security\Authorization;

use Dedi\SyliusSettingsPlugin\Security\Authorization\Checker\AuthorizationCheckerInterface;

class CheckerRegistry
{
    /** @var AuthorizationCheckerInterface[] */
    private array $checkers = [];

    public function __construct()
    {
    }

    public function addChecker(AuthorizationCheckerInterface $checker)
    {
        $this->checkers[] = $checker;
    }

    public function getChecker(string $type): ?AuthorizationCheckerInterface
    {
        foreach ($this->checkers as $checker) {
            if ($type === $checker->getType()) {
                return $checker;
            }
        }

        return null;
    }
}
